<template>
  <div class="p-5 h-full">
    <div class="grid grid-cols-3">
      <div></div>
      <div class="text-center text-4xl">S'inscrire</div>
    </div>
    <div class="flex flex-row justify-center">
      <v-form :value="valid" ref="form" @submit.prevent="signUp">
        <div
          class="flex flex-col border border-gray-100 rounded-xl p-5 items-center mt-20"
        >
          <v-text-field
            label="Nom"
            id="nom"
            v-model="user.nom"
            :rules="nomRules"
            autocomplete="family-name"
          />
          <v-text-field
            label="Prénom"
            id="prenom"
            :rules="prenomRules"
            v-model="user.prenom"
            autocomplete="given-name"
          />
          <v-text-field
            label="E-mail"
            id="email"
            type="email"
            :rules="emailRules"
            v-model="user.email"
            :error-messages="errMessage"
            autocomplete="email"
          />
          <v-text-field
            label="Mot de passe"
            id="password"
            type="password"
            :rules="passwordRules"
            v-model="user.password"
            autocomplete="new-password"
          />
          <v-btn
            text
            color="primary"
            type="submit"
            :loading="loading"
            :disabled="loading"
            >S'inscrire</v-btn
          >
        </div>
      </v-form>
    </div>
  </div>
</template>

<script>
export default {
  methods: {
    signUp() {
      if (this.$refs.form.validate()) {
        this.loading = true;

        this.$store.dispatch("signUp", this.user).catch((err) => {
          if (err.code == "auth/email-already-in-use") {
            this.$refs.form.reset();
            this.errMessage = "L'adresse mail existe déjà";
          }
          this.loading = false;
        });
      }
    },
  },
  data() {
    return {
      valid: false,
      loading: false,
      user: Object,
      errMessage: "",
      nomRules: [(v) => !!v || "Le nom est requis"],
      prenomRules: [(v) => !!v || "Le prénom est requis"],
      passwordRules: [(v) => !!v || "Le mot de passe est requis"],
      emailRules: [
        (v) => !!v || "Le mail est requis",
        (v) =>
          /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) ||
          "Le mail n'est pas valide",
      ],
    };
  },
};
</script>

<style>
</style>